/*----- PROTECTED REGION ID(AlarmNotifyClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        AlarmNotifyClass.h
//
// description : Include for the AlarmNotify root class.
//               This class is the singleton class for
//                the AlarmNotify device class.
//               It contains all properties and methods which the 
//               AlarmNotify requires only once e.g. the commands.
//
// project :     Alarm Notify
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Elettra-Sincrotrone Trieste S.C.p.A. di interesse nazionale
// Strada Statale 14 - km 163,5 in AREA Science Park
// 34149 Basovizza, Trieste ITALY
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AlarmNotifyClass_H
#define AlarmNotifyClass_H

#include <tango.h>
#include <AlarmNotify.h>


/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass.h


namespace AlarmNotify_ns
{
/*----- PROTECTED REGION ID(AlarmNotifyClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute alarmStatus class definition
class alarmStatusAttrib: public Tango::SpectrumAttr
{
public:
	alarmStatusAttrib():SpectrumAttr("alarmStatus",
			Tango::DEV_STRING, Tango::READ, 10000) {};
	~alarmStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AlarmNotify *>(dev))->read_alarmStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AlarmNotify *>(dev))->is_alarmStatus_allowed(ty);}
};

//	Attribute handlerStatus class definition
class handlerStatusAttrib: public Tango::SpectrumAttr
{
public:
	handlerStatusAttrib():SpectrumAttr("handlerStatus",
			Tango::DEV_STRING, Tango::READ, 1000) {};
	~handlerStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AlarmNotify *>(dev))->read_handlerStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AlarmNotify *>(dev))->is_handlerStatus_allowed(ty);}
};

//	Attribute alarmReceivers class definition
class alarmReceiversAttrib: public Tango::SpectrumAttr
{
public:
	alarmReceiversAttrib():SpectrumAttr("alarmReceivers",
			Tango::DEV_STRING, Tango::READ, 10000) {};
	~alarmReceiversAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AlarmNotify *>(dev))->read_alarmReceivers(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AlarmNotify *>(dev))->is_alarmReceivers_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command GetAlarmInfo class definition
class GetAlarmInfoClass : public Tango::Command
{
public:
	GetAlarmInfoClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetAlarmInfoClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetAlarmInfoClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AlarmNotify *>(dev))->is_GetAlarmInfo_allowed(any);}
};


/**
 *	The AlarmNotifyClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  AlarmNotifyClass : public Tango::DeviceClass
#else
class AlarmNotifyClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(AlarmNotifyClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AlarmNotifyClass::Additionnal DServer data members

	//	Class properties data members
	public:
		//	MaxSearchSize:	Max size of search result
		Tango::DevLong	maxSearchSize;
		//	SubscribePeriod:	Period in seconds
		Tango::DevLong	subscribePeriod;
	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static AlarmNotifyClass *init(const char *);
		static AlarmNotifyClass *instance();
		~AlarmNotifyClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		AlarmNotifyClass(string &);
		static AlarmNotifyClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	AlarmNotify_H
